<?php

namespace DHLParcel\Shipping\Model\Service;

use DHLParcel\Shipping\Model\Core\SingletonAbstract;
use DHLParcel\Shipping\Model\Core\TranslateTrait;
use DHLParcel\Shipping\Model\Data\Api\Response\Capability\Option;

class OptionService extends SingletonAbstract
{
    use TranslateTrait;

    public function getLabels()
    {
        return [
            Option::KEY_DOOR                => $this->l('Delivery to the door'),
            Option::KEY_PS                  => $this->l('Servicepoint delivery'),
            Option::KEY_BP                  => $this->l('Mailpost delivery'),
            Option::KEY_SDD                 => $this->l('Same day'),
            Option::KEY_EA                  => $this->l('Extra assurance'),
            Option::KEY_HANDT               => $this->l('Signature'),
            Option::KEY_EVE                 => $this->l('Evening'),
            Option::KEY_NBB                 => $this->l('No neighbour'),
            Option::KEY_AGE_CHECK           => $this->l('Age check 18+'),
            Option::KEY_INS                 => $this->l('All risks insurance'),
            Option::KEY_S                   => $this->l('Saturday'),
            Option::KEY_EXP                 => $this->l('Expresser'),
            Option::KEY_BOUW                => $this->l('Construction site'),
            Option::KEY_REFERENCE           => $this->l('Reference'),
            Option::KEY_REFERENCE2          => $this->l('Reference 2'),
            Option::KEY_EXW                 => $this->l('Ex Works'),
            Option::KEY_RECAP               => $this->l('Recap'),
            Option::KEY_ADD_RETURN_LABEL    => $this->l('Print extra label for return shipment'),
            Option::KEY_SSN                 => $this->l('Undisclosed sender'),
            Option::KEY_PERS_NOTE           => $this->l('E-mail to receiver'),
            Option::KEY_IS_BULKY            => $this->l('Is bulky'),
            Option::KEY_BMC                 => $this->l('Secure delivery by code')
        ];
    }

    public function getLabel($optionKey)
    {
        if (array_key_exists($optionKey, $this->getLabels())) {
            return $this->getLabels()[$optionKey];
        }

        return $optionKey;
    }
}
